<?php

class Widget_Donation_Goal extends WP_Widget{
	function Widget_Donation_Goal(){
		$widget_options = array(
			'classname' => 'widget-donation-goal',
			'description' => _('Donation Goal')
		);
		$control_options = array(
			'height' => 300,
			'width' => 250
		);
		$this->WP_Widget( 'widget_donation_goal', _('Donation Goal'), $widget_options, $control_options );
	}
	function widget( $args, $instance ){
		extract( $args, EXTR_SKIP );
		//$title = ( $instance['title'] ) ? $instance['title']  : 'Donation Goal';
		if( $instance['title'] == '' ){
			$instance['title'] = 'Donation Goal';
			$title = $instance['title'];
		} else {
			$title = ( $instance['title'] ) ;
		}
		
		echo $before_widget;
		echo "<div style='position:relative;'>";
		echo $before_title;
			echo esc_html( $instance['title'] );
		echo $after_title;
		//echo $example_data;
		
		$options = get_option('donation_goal_options');
		//echo $options[ 'clip_height' ];
		//echo $options[ 'image_height' ];
		//$intro_text = ( $options['intro_text'] ) ? $options['intro_text'] : 'Please fill out intro text';
		//echo "<p>$intro_text" .  "</p>";
		if( $options['intro_text'] != '' ){
			echo "<div class='donation-goal-intro-text'>{$options['intro_text']}</div>";
		}
		?>
		<div class="donation_goal_widget_parent">
		<?php
			if(preg_match('/(jpg|jpeg|png|gif)$/', $options['image_with_fill']) && preg_match('/(jpg|jpeg|png|gif)$/', $options['image_without_fill'])):
		?>
		<img class="donation_full" src="<?php echo $options['image_with_fill']; ?>" alt="" />
		<img class="donation_empty"  style="<?php echo $options['clip_rule']; ?>" src="<?php echo $options['image_without_fill']; ?>" alt="" />
		<?php endif ?>
		</div>
		<?php 
			if( $options['donation'] != '' ){
			echo "<div class='donation-goal-donate-section'>{$options['donation']}</div>";
			}
		 ?>
		<?php
		//echo '<p><a href="http://www.bullfrog-media.com/">Donation Goals plugin by Bullfrog Media LLC</a></p>';
		echo "</div>";
		echo $after_widget;
	}
	function form( $instance ){
	?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>">
				<?php _e( 'Title' ); ?>
				<input id="<?php echo $this->get_field_id( 'title' ); ?>" 
						name="<?php echo $this->get_field_name( 'title' ); ?>"
						value="<?php echo esc_attr( $instance['title'] ); ?>"
				/>
			</label>
		</p>
	<?php
	}
	function update( $new_instance, $old_instance ){
		$instance = $old_instance;
		$instance['title'] =  esc_html( $new_instance['title'] );
		return $instance;
	}
}
function widget_donation_goal_init(){
	register_widget('Widget_Donation_Goal');
}
add_action( 'widgets_init','widget_donation_goal_init' );

function js_clip()
{
	$options = get_option('donation_goal_options');
	$url = get_bloginfo( 'url' ) . '/wp-content/plugins/donate-goal/donation-goal-widget.js';
	wp_enqueue_script('jquery');
	wp_register_script('widget_js', $url, array('jquery'));
	wp_enqueue_script('widget_js');
	$data = array(
		'javascript_clip_rule' => $options['javascript_clip']
	);
	wp_localize_script('widget_js', 'object_name', $data);
	
}

if(!is_admin()){
	if(is_active_widget(false, false, 'widget_donation_goal', true))
	{
		add_action('init', 'js_clip');
	}
}

