<?php
/*
Plugin Name: Donation Goals
Plugin URI: http://www.bullfrog-media.com/plugins
Description: Donate Goal allows you to have a meter to showcase the amount of money your charitable organization or foundation has raised using an image in your widgetized area.
Version: 1.0.3
Author: Bullfrog Media
Author URI: http://www.bullfrog-media.com/ 
*/

/**
 * Copyright (c) 2011 Bullfrog Media LLC. All rights reserved.
 *
 * Released under the GPL license
 * http://www.opensource.org/licenses/gpl-license.php
 *
 * This is an add-on for WordPress
 * http://wordpress.org/
 *
 * **********************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * **********************************************************************
 */
?>
<?php
/*--------------------------------------------------------------------------
	Require Widget File
--------------------------------------------------------------------------*/
require('donation-goal-widget.php');

/*--------------------------------------------------------------------------
	Require Silent Post Framework	
--------------------------------------------------------------------------*/
require('silent-post-framework.php');

/*--------------------------------------------------------------------------
	Require Media Uploader	
--------------------------------------------------------------------------*/
require('media-uploader.php');


/*--------------------------------------------------------------------------
	Add menu and submenu
--------------------------------------------------------------------------*/
add_action( 'admin_menu', 'add_new_menu_section' ); 
add_action( 'admin_menu', 'add_submenu_section' );
function add_new_menu_section(){
	add_menu_page( 'Donation Goals Settings', 'Donation Goals', 'administrator', __FILE__, 'donation_goal_admin'  );
}
function add_submenu_section(){
	add_submenu_page( __FILE__, 'Settings', 'Settings', 'administrator', __FILE__);
}

/*--------------------------------------------------------------------------
	Set up admin page
--------------------------------------------------------------------------*/
function donation_goal_admin(){
?>
	<div id="theme-options-wrap" class="widefat">
		<div class="icon32" id="icon-tools"><br /></div>
		<?php 
		
		$options = get_option('donation_goal_options');
		//print_r(get_option('donation_goal_options'));
		if(!empty($options['errors']))
			echo implode( '<br />', $options['errors'] );	
		//print_r(getimagesize('http://localhost:8888/donation-goal/wp-content/uploads/2011/01/thermifull15.png'));
	
		?>
		<form method="POST" action="options.php" enctype="multipart/form-data">
			<?php settings_fields('donation_goal_options'); ?>
			<?php do_settings_sections(__FILE__); ?>
			<p class="submit">
				<input name="submit" type="submit" class="button-primary" value="<?php esc_attr_e('Update Settings'); ?>" />
			</p>
		</form>
	</div><!-- //#theme-options-wrap -->
	<div class="donation_goal_about">
		<h2> Bullfrog Media</h2>
		<img src="<?php echo get_bloginfo('url'); ?>/wp-content/plugins/donate-goal/bullfrog-media-logo.png" style="float: left; padding-right: 20px" alt="bullfrog media logo" />
		<p>Bullfrog Media offers creative services and expertise in the fields of social media, marketing and web development. Our focus on strategic messaging will help establish your brand online. From original marketing concept through implementation and ongoing maintenance, we empower you to manage your identity effectively, track marketing progress and continually explore new and emerging technologies to interact with your clients.</p>

		<p>Each member of our team has over six years of experience in social media, community management and online marketing, and have developed marketing strategies for organizations spanning small businesses like the local skateboard shop to large organizations such as Coca Cola and The Grammys.</p>

		
		<p><form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="kate.wormington@gmail.com">
<input type="hidden" name="lc" value="US">
<input type="hidden" name="item_name" value="Donation Goals plugin">
<input type="hidden" name="no_note" value="0">
<input type="hidden" name="currency_code" value="USD">
<input type="hidden" name="bn" value="PP-DonationsBF:btn_donateCC_LG.gif:NonHostedGuest">
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
</p>
	</div>
<?php	
}

/*--------------------------------------------------------------------------
	Register & Build  Fields
--------------------------------------------------------------------------*/
add_action( 'admin_init', 'register_and_build_fields' );
function register_and_build_fields(){
	register_setting( 'donation_goal_options', 'donation_goal_options', 'validate_options');

	add_settings_section( 'main_section', 'Donation Goals Settings', 'section_cb', __FILE__ );

	add_settings_field( 'intro_text', '<strong>Introduction Text</strong><br /<br />Write an introduction about your charity or cause. Style the text easily using the WYSIWYG editor, or use images by taking advantage of the upload/insert tools.', 'intro_text', __FILE__, 'main_section' );

	add_settings_field( 'donation', '<strong>Donate Url</strong><br /><br />Use a call to action. Here you can specify donation instruction or post a button using the upload/insert or any html you want.', 'donation', __FILE__, 'main_section' );

	add_settings_field( 'amount_needed', '<strong>Amount Needed</strong><br /><br />Enter your fundraising goal here. Use numbers only - no symbols or punctuation.', 'amount_needed', __FILE__, 'main_section' );

	add_settings_field( 'amount_raised', '<strong>Amount Raised</strong><br /><br />Enter the total amount raised to date. Use numbers only - no symbols or punctuation.', 'amount_raised', __FILE__, 'main_section' );

	add_settings_field( 'percentage_raised', '<strong>Percentage Raised</strong><br /><br />Percentage raised. This number is automatically calculated after the settings are updated.', 'percentage_raised', __FILE__, 'main_section' );

	add_settings_field( 'orientation', '<strong>Orientation</strong><br /><br />Is your image vertical or horizontal?', 'orientation', __FILE__, 'main_section' );


	add_settings_field( 'image_without_fill', '<strong>Image Without Fill</strong><br /><br />Paste the full URL to an image (including http://) or upload an image. To upload an image, click upload and then go through the steps and <strong>click insert into post</strong>.', 'image_without_fill', __FILE__, 'main_section' );

	add_settings_field( 'image_with_fill', '<strong>Image With Fill</strong><br /><br />Paste the URL to an image  (including http://) or upload an image. To upload an image, click upload and then go through the steps and <strong>click insert into post</strong>.', 'image_with_fill', __FILE__, 'main_section' );
}

function intro_text(){
	$options = get_option( 'donation_goal_options' );
	echo '<div id="postrichdiv" class="postarea">';
	the_editor($options['intro_text'], $id = 'donation_goal_options[intro_text]', $media_buttons = true );
	echo '</div>';
	//echo "<p><br /><strong>Write an introduction about your charity or cause. Style the text easily using the WYSIWYG editor, or use images by taking advantage of the upload/insert tools.</strong></p>"; 
}

function donation(){
	$options = get_option( 'donation_goal_options' );
	echo '<div id="postrichdiv1" class="postarea">';
	the_editor($options['donation'], $id = 'donation_goal_options[donation]' );
	echo '</div>';
	//echo "<p><br />Use a call to action. Here you can specify donation instruction or post a button using the upload/insert or any html you want.</p>"; 
}

function amount_needed(){
	$options = get_option( 'donation_goal_options' );
	echo "<input name='donation_goal_options[amount_needed]' type='text' value='{$options['amount_needed']}' />";
	//echo "<p><br />Enter your fundraising goal here. Use numbers only - no symbols or punctuation.</p>";
}

function amount_raised(){
	$options = get_option( 'donation_goal_options' );
	echo "<input name='donation_goal_options[amount_raised]' type='text' value='{$options['amount_raised']}' />";
	//echo "<p><br />Enter the total amount raised to date. Use numbers only - no symbols or punctuation.</p>";
}

function percentage_raised(){
		$options = get_option( 'donation_goal_options' );	
		echo "<input name='donation_goal_options[percentage_raised]' type='text' value='{$options['percentage_raised']}' READONLY/>";	
		//echo "<p><br />Percentage raised. This number is automatically calculated after the settings are updated.</p>";
}

function orientation(){
	$options = get_option( 'donation_goal_options' );
	if($options['orientation'] == 'vertical'){
		$selectedv = 'selected';
	}
	if($options['orientation'] == 'horizontal'){
		$selectedh = 'SELECTED';
	}

	echo "<p>";
	echo "<select name='donation_goal_options[orientation]'>";
		echo "<option value='vertical'". $selectedv .">vertical</option>";
		echo "<option value='horizontal'".$selectedh.">horizontal</option>";
	echo "</select>";
	echo "</p>";
	
	//echo "<p><br />Is your image vertical or horizontal?</p>";
}

function image_without_fill(){
	$options = get_option( 'donation_goal_options' );
	//get_silent_posts( $options['image_without_fill_postid'], 'upload_image_without_fill' );
	//echo "<input id='upload_image_without_fill_postid' type='hidden' name='donation_goal_options[image_without_fill_postid]' value='". get_silent_posts( $options['image_without_fill_postid'], 'upload_image_without_fill' ) ."' />";
	echo "<input id='upload_image_without_fill' type='text' name='donation_goal_options[image_without_fill]' value='{$options['image_without_fill']}' rel='". get_silent_posts('upload_image_without_fill') ."' size='75' />";
	echo "<input id='image_without_fill_button' type='button'  value='upload image' />";
	//echo "<p><br />Paste the full URL to an image (including http://) or upload an image. To upload an image, click upload and then go through the steps and <strong>click insert into post</strong>.</p>";
}

function image_with_fill(){
	$options = get_option( 'donation_goal_options' );
	echo "<input id='upload_image_with_fill' type='text' name='donation_goal_options[image_with_fill]' value='{$options['image_with_fill']}' rel='". get_silent_posts('upload_image_with_fill') ."' size='75' />";
	echo "<input id='image_with_fill_button' type='button'  value='upload image' />";
	//echo "<p><br />Paste the full URL to an image (including http://) or upload an image. To upload an image, click upload and then go through the steps and <strong>click insert into post</strong>.</p>";
}

/*--------------------------------------------------------------------------
	Validate Options
--------------------------------------------------------------------------*/
function validate_options( $donation_goal_options ){
	//validate  for no dollar signs in amounts
	$errors = array();
	$patterns = array();
	$patterns[0] = '/\$/';
	$patterns[1] = '/[a-z]/';
	$patterns[3] = '/\#/';	
	$donation_goal_options['amount_needed'] = preg_replace( $patterns, '', $donation_goal_options['amount_needed'] );
	$donation_goal_options['amount_raised'] = preg_replace( $patterns, '', $donation_goal_options['amount_raised'] );

	if( $donation_goal_options['amount_needed'] != '' && $donation_goal_options['amount_needed'] != 0 ){
		$donation_goal_options['percentage_raised'] = round( (($donation_goal_options['amount_raised']) / $donation_goal_options['amount_needed'] ) * (100) ,2);
	} else {
		$donation_goal_options['percentage_raised'] = 0;
	}
	
	
	//check filled image 
	if(!$donation_goal_options['image_with_fill'] == '')
	{
		if(!preg_match('/(jpg|jpeg|png|gif)$/', $donation_goal_options['image_with_fill']))
		{
			$donation_goal_options['errors']['image_with_fill_type'] = 'Please check if the image with fill is valid';
		}else{
			$donation_goal_options['errors']['image_with_fill_type'] = '';
		}//end of checking if image with fill is an image

	}//end of checking of image with fill is blank

	//check unfilled image 
	if(!$donation_goal_options['image_without_fill'] == '')
	{
		//check if it is an image 
		if(preg_match('/(jpg|jpeg|png|gif)$/', $donation_goal_options['image_without_fill']))
		{
			$donation_goal_options['errors']['invalid_unfilled_type'] = '';
			//get image height
			if(list($width, $height) = @getimagesize( $donation_goal_options['image_without_fill']))
			{
				$donation_goal_options['errors']['unable_to_open_image'] = '';
				$donation_goal_options['image_width'] = $width;
				$donation_goal_options['image_height'] = $height;

			if($donation_goal_options['orientation'] == 'vertical' ){
				$donation_goal_options['clip'] = (1 - ($donation_goal_options['percentage_raised'] / 100)) * $donation_goal_options['image_height'];
				$donation_goal_options['clip_rule'] = "clip:rect(0px," . $donation_goal_options['image_width'] ."px,  ". $donation_goal_options['clip'] . "px, 0px);";
				
				$donation_goal_options['javascript_clip'] = "rect(0px," . $donation_goal_options['image_width'] . "px, ". $donation_goal_options['clip'] . "px, 0px)";
				
			}elseif( $donation_goal_options['orientation'] == 'horizontal' ){
				$donation_goal_options['clip'] = ($donation_goal_options['percentage_raised'] / 100) * $donation_goal_options['image_width'];
				$donation_goal_options['clip_rule'] = "clip:rect(0px,". $donation_goal_options['image_width']."px,  ". $donation_goal_options['image_height'] . "px," . $donation_goal_options['clip'] . "px);";
				
				$donation_goal_options['javascript_clip'] = "rect(0px," . $donation_goal_options['image_width'] . "px, ". $donation_goal_options['image_height'] . "px, " . $donation_goal_options['clip'] . "px)";
			} else {
				$donation_goal_options['clip'] = '';
			}
				

			} else {
					$donation_goal_options['errors']['unable_to_open_image'] = 'Unable to retrieve the un-filled image. Please check the following:Permissions on the image, File URL Access is on and if the image exists.'; 
			}//end of fopen
		} else {
				$donation_goal_options['errors']['invalid_unfilled_type'] = 'Please check if the unfilled image is valid ';
		}//end of checking if it's an image 
	} //end of image field not blank

	return $donation_goal_options;
}

/*--------------------------------------------------------------------------
	section_cb
--------------------------------------------------------------------------*/
function section_cb(){}

/*--------------------------------------------------------------------------
	Loading javascript and css
--------------------------------------------------------------------------*/
function my_admin_scripts(){
	wp_enqueue_script( 'media-upload' );
	wp_enqueue_script( 'thickbox' );
	wp_register_script( 'my_upload', get_bloginfo( 'url' ) . '/wp-content/plugins/donate-goal/donation-goal-scripts.js', array( 'jquery', 'media-upload', 'thickbox' ) );
	wp_enqueue_script( 'my_upload' );
}

function my_admin_styles(){
	wp_enqueue_style( 'thickbox' );
}
//echo $_GET['page'];
if( isset( $_GET['page'] ) && $_GET['page'] == 'donate-goal/donation-goal.php' ){
	add_action( 'admin_print_scripts', 'my_admin_scripts' );
	add_action( 'admin_print_styles', 'my_admin_styles' );
}
add_action( 'admin_head', 'admin_register_donation_goal_styles' );
function admin_register_donation_goal_styles(){
	$url = get_bloginfo( 'url' ) . '/wp-content/plugins/donate-goal/donation-goal-admin.css';
	echo "<link rel='stylesheet' href='$url' />\r\n"; 
}
add_action( 'wp_head', 'widget_register_doantion_styles');
function widget_register_doantion_styles(){
	$url = get_bloginfo( 'url' ) . '/wp-content/plugins/donate-goal/donation-goal-widget.css';
	echo "<link rel='stylesheet' href='$url' />\r\n";
}
add_filter('admin_head','donation_goal_tinymce');

function donation_goal_tinymce() {
	wp_admin_css('thickbox');
	wp_print_scripts('jquery-ui-core');
	wp_print_scripts('jquery-ui-tabs');
	wp_print_scripts('post');
	wp_print_scripts('editor');
	add_thickbox();
	wp_print_scripts('media-upload');
	if (function_exists('wp_tiny_mce')) wp_tiny_mce();
// use the if condition because this function doesn't exist in version prior to 2.7
}

//add a settings link on the plugins page
function donation_goal_settings_link($links){
  $settings_link = '<a href="admin.php?page=donate-goal/donation-goal.php">Settings</a>';
  array_unshift($links, $settings_link);
  return $links;
}

$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", "donation_goal_settings_link");

